/*
 * logistic_map.c
 *
 * INTRODUCTION
 * 
 * HISTORY:
 * INSERT DATE AND YOUR NAME HERE
 * 1/9/2011  Created by Nelson Rosa
 *
 */

/******************************************************************************
 * PREPROCESSOR COMMANDS
 *
 * Library "include" files, constants, etc.
 ******************************************************************************/


/******************************************************************************
 * STRUCTS AND STRUCT VARIABLE TYPES
 ******************************************************************************/

/******************************************************************************
 * GLOBAL VARIABLES
 ******************************************************************************/

char *myinputs[] = {
	/**** FILL ARRAY WITH YOUR VALUES ****/
};

/******************************************************************************
 * FUNCTION PROTOTYPES
 ******************************************************************************/

/******************************************************************************
 * MAIN FUNCTION
 ******************************************************************************/

/* main
*
* Processes up to MAX_INPUTS from the user.  If an invalid input is detected
* the program terminates early.  After the population growth of the last input 
* is computed, the results of all the inputs are sent to the ouput function 
* sendOutput.
*/

int main(void) {
	int i;
	/* WRITE CODE HERE THAT
		o defines any additional variables that will help you with the
		rest of your code in this function (an array of Params might be useful)
	*/
	
	// initialize the UART1 serial port
	initUart1();
	
	i = 0;
	while(i < MAX_INPUTS) {
		/*	WRITE CODE HERE THAT
				o takes a Params struct and fills it in with input from a user
					i) there should be one unique Params struct per input
				o if the parameters are valid
					i)allocate space for that structs population array
					ii)call a function to calculate its population growth
				o if the parameters are not valid, then break out of the loop
					i) see Essential C, pp. 13-14 on how to use 'break'
				o keeps track of the number of inputs received
			
			You should use the other functions in this file to your advantage.
		*/
	}
	
	/* WRITE CODE HERE THAT
		o if MAX_INPUTS are received, then calls a function that will print an
			array of Params.
	*/

	/* WRITE CODE HERE THAT
	 	o calls a function that will return any allocated memory back to the heap.
	 		The function will expect an array of Params.
	*/
	
	return 0;
}

/* getUserInput
 * 
 * This reads the user's input into the struct pointed at by lgmapp, 
 * and returns TRUE if the input is valid, FALSE if not.  All inputs
 * are assumed to contain three (3) floats per line: the initial 
 * population, growth rate, and the n-th year to calculate, in that 
 * order.  For example, the input: "0.8 3.35 10.78" implies that after 
 * this function returns the fields in lgmap are:
 *				x0 = 0.8, rate = 3.35, and years = 10, 
 * where digits after the decimal point in years are dropped.
 */

int getUserInput(Params *lgmapp) {
	int valid;
	char input[256];
	float years;
	
	/* WRITE CODE HERE THAT 
		o gets a string of input from stdin
		o uses sscanf to parse the input string
			i) assume the input string contains 3 floats,
				your format string in sscanf should reflect this
			ii) WARNING: you can't pass lgmapp->years directly into 
				sscanf like in invest.c.  Think carefully about what
				you have to do to convert your input into an int.  Your
				solution should make use of one of the local variables.
		o places the numeric values of the input into the Params struct
		o returns true, if the inputs are within the
			ranges specified in Assignment 1
	*/
	
	printf("Valid inputs?  %d\n",valid);
	
	if (!valid) {
		printf("Invalid input; exiting.\n");
	}
	
	return(valid);
}

/* allocatePopulationArray
 *
 * This dynamically allocates the memory for the population array from
 * the "heap."  Don't forget to set a heap size under "Project->Build Options"
 */

float *allocatePopulationArray(int years) {
	/* WRITE CODE HERE THAT 
		o returns a float * pointer from the heap using malloc
			i) see Essential C, pp. 38-39 for the definition of
			malloc and example usage.
	*/
}

/* calculatePopulation
 *
 * This fills the array of one (1) Params structure with the 
 * population over the years.
 */

void calculatePopulation(Params *lgmapp) {	
	/* WRITE CODE HERE THAT 
		o calculates the logistic map from 0 to n years
			and stores the result in the population field
			of lgmapp.
	*/
}

/* sendOutput
 *
 * This function prints the results.
 */

void sendOutput(Params *lgmap_array) {
  /* WRITE CODE HERE THAT 
  	o prints the result of all MAX_INPUTS inputs correct
		to 5 decimal places in a format similar to the output 
		shown in Assignment 1.
  */
}

/* freePopulationArrays
 *
 * This frees the memory used by the first n elements of an array of
 * Param objects.
 */

void freePopulationArrays(Params *lgmap_array, int n) {
	/* WRITE CODE HERE THAT 
		o frees the allocated memory of the first n elements
			of an array of Params.
	*/
}